diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ID3/module.audio.dts.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ID3/module.audio.dts.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ID3/module.audio.dts.php	1969-12-31 18:00:00.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ID3/module.audio.dts.php	2013-03-20 23:55:42.000000000 -0500
***************
*** 0 ****
--- 1,290 ----
+ <?php
+ /////////////////////////////////////////////////////////////////
+ /// getID3() by James Heinrich <info@getid3.org>               //
+ //  available at http://getid3.sourceforge.net                 //
+ //            or http://www.getid3.org                         //
+ /////////////////////////////////////////////////////////////////
+ // See readme.txt for more details                             //
+ /////////////////////////////////////////////////////////////////
+ //                                                             //
+ // module.audio.dts.php                                        //
+ // module for analyzing DTS Audio files                        //
+ // dependencies: NONE                                          //
+ //                                                             //
+ /////////////////////////////////////////////////////////////////
+ 
+ 
+ /**
+ * @tutorial http://wiki.multimedia.cx/index.php?title=DTS
+ */
+ class getid3_dts extends getid3_handler
+ {
+ 	/**
+ 	* Default DTS syncword used in native .cpt or .dts formats
+ 	*/
+     const syncword = "\x7F\xFE\x80\x01";
+ 
+ 	private $readBinDataOffset = 0;
+ 
+     /**
+     * Possible syncwords indicating bitstream encoding
+     */
+     public static $syncwords = array(
+     	0 => "\x7F\xFE\x80\x01",  // raw big-endian
+     	1 => "\xFE\x7F\x01\x80",  // raw little-endian
+     	2 => "\x1F\xFF\xE8\x00",  // 14-bit big-endian
+     	3 => "\xFF\x1F\x00\xE8"); // 14-bit little-endian
+ 
+ 	public function Analyze() {
+ 		$info = &$this->getid3->info;
+ 		$info['fileformat'] = 'dts';
+ 
+ 		$this->fseek($info['avdataoffset']);
+ 		$DTSheader = $this->fread(20); // we only need 2 words magic + 6 words frame header, but these words may be normal 16-bit words OR 14-bit words with 2 highest bits set to zero, so 8 words can be either 8*16/8 = 16 bytes OR 8*16*(16/14)/8 = 18.3 bytes
+ 
+ 		// check syncword
+ 		$sync = substr($DTSheader, 0, 4);
+         if (($encoding = array_search($sync, self::$syncwords)) !== false) {
+ 
+         	$info['dts']['raw']['magic'] = $sync;
+ 			$this->readBinDataOffset = 32;
+ 
+         } elseif ($this->isDependencyFor('matroska')) {
+ 
+ 			// Matroska contains DTS without syncword encoded as raw big-endian format
+ 			$encoding = 0;
+ 			$this->readBinDataOffset = 0;
+ 
+         } else {
+ 
+ 			unset($info['fileformat']);
+ 			return $this->error('Expecting "'.implode('| ', array_map('getid3_lib::PrintHexBytes', self::$syncwords)).'" at offset '.$info['avdataoffset'].', found "'.getid3_lib::PrintHexBytes($sync).'"');
+ 
+ 		}
+ 
+ 		// decode header
+ 		$fhBS = '';
+ 		for ($word_offset = 0; $word_offset <= strlen($DTSheader); $word_offset += 2) {
+ 			switch ($encoding) {
+ 				case 0: // raw big-endian
+ 					$fhBS .=        getid3_lib::BigEndian2Bin(       substr($DTSheader, $word_offset, 2) );
+ 					break;
+ 				case 1: // raw little-endian
+ 					$fhBS .=        getid3_lib::BigEndian2Bin(strrev(substr($DTSheader, $word_offset, 2)));
+ 					break;
+ 				case 2: // 14-bit big-endian
+ 					$fhBS .= substr(getid3_lib::BigEndian2Bin(       substr($DTSheader, $word_offset, 2) ), 2, 14);
+ 					break;
+ 				case 3: // 14-bit little-endian
+ 					$fhBS .= substr(getid3_lib::BigEndian2Bin(strrev(substr($DTSheader, $word_offset, 2))), 2, 14);
+ 					break;
+ 			}
+ 		}
+ 
+ 		$info['dts']['raw']['frame_type']             =        $this->readBinData($fhBS,  1);
+ 		$info['dts']['raw']['deficit_samples']        =        $this->readBinData($fhBS,  5);
+ 		$info['dts']['flags']['crc_present']          = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['raw']['pcm_sample_blocks']      =        $this->readBinData($fhBS,  7);
+ 		$info['dts']['raw']['frame_byte_size']        =        $this->readBinData($fhBS, 14);
+ 		$info['dts']['raw']['channel_arrangement']    =        $this->readBinData($fhBS,  6);
+ 		$info['dts']['raw']['sample_frequency']       =        $this->readBinData($fhBS,  4);
+ 		$info['dts']['raw']['bitrate']                =        $this->readBinData($fhBS,  5);
+ 		$info['dts']['flags']['embedded_downmix']     = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['flags']['dynamicrange']         = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['flags']['timestamp']            = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['flags']['auxdata']              = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['flags']['hdcd']                 = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['raw']['extension_audio']        =        $this->readBinData($fhBS,  3);
+ 		$info['dts']['flags']['extended_coding']      = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['flags']['audio_sync_insertion'] = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['raw']['lfe_effects']            =        $this->readBinData($fhBS,  2);
+ 		$info['dts']['flags']['predictor_history']    = (bool) $this->readBinData($fhBS,  1);
+ 		if ($info['dts']['flags']['crc_present']) {
+ 			$info['dts']['raw']['crc16']              =        $this->readBinData($fhBS, 16);
+ 		}
+ 		$info['dts']['flags']['mri_perfect_reconst']  = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['raw']['encoder_soft_version']   =        $this->readBinData($fhBS,  4);
+ 		$info['dts']['raw']['copy_history']           =        $this->readBinData($fhBS,  2);
+ 		$info['dts']['raw']['bits_per_sample']        =        $this->readBinData($fhBS,  2);
+ 		$info['dts']['flags']['surround_es']          = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['flags']['front_sum_diff']       = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['flags']['surround_sum_diff']    = (bool) $this->readBinData($fhBS,  1);
+ 		$info['dts']['raw']['dialog_normalization']   =        $this->readBinData($fhBS,  4);
+ 
+ 
+ 		$info['dts']['bitrate']              = self::bitrateLookup($info['dts']['raw']['bitrate']);
+ 		$info['dts']['bits_per_sample']      = self::bitPerSampleLookup($info['dts']['raw']['bits_per_sample']);
+ 		$info['dts']['sample_rate']          = self::sampleRateLookup($info['dts']['raw']['sample_frequency']);
+ 		$info['dts']['dialog_normalization'] = self::dialogNormalization($info['dts']['raw']['dialog_normalization'], $info['dts']['raw']['encoder_soft_version']);
+ 		$info['dts']['flags']['lossless']    = (($info['dts']['raw']['bitrate'] == 31) ? true  : false);
+ 		$info['dts']['bitrate_mode']         = (($info['dts']['raw']['bitrate'] == 30) ? 'vbr' : 'cbr');
+ 		$info['dts']['channels']             = self::numChannelsLookup($info['dts']['raw']['channel_arrangement']);
+ 		$info['dts']['channel_arrangement']  = self::channelArrangementLookup($info['dts']['raw']['channel_arrangement']);
+ 
+ 		$info['audio']['dataformat']          = 'dts';
+ 		$info['audio']['lossless']            = $info['dts']['flags']['lossless'];
+ 		$info['audio']['bitrate_mode']        = $info['dts']['bitrate_mode'];
+ 		$info['audio']['bits_per_sample']     = $info['dts']['bits_per_sample'];
+ 		$info['audio']['sample_rate']         = $info['dts']['sample_rate'];
+ 		$info['audio']['channels']            = $info['dts']['channels'];
+ 		$info['audio']['bitrate']             = $info['dts']['bitrate'];
+ 		if (isset($info['avdataend']) && !empty($info['dts']['bitrate']) && is_numeric($info['dts']['bitrate'])) {
+ 			$info['playtime_seconds']         = ($info['avdataend'] - $info['avdataoffset']) / ($info['dts']['bitrate'] / 8);
+ 			if (($encoding == 2) || ($encoding == 3)) {
+ 				// 14-bit data packed into 16-bit words, so the playtime is wrong because only (14/16) of the bytes in the data portion of the file are used at the specified bitrate
+ 				$info['playtime_seconds'] *= (14 / 16);
+ 			}
+ 		}
+ 		return true;
+ 	}
+ 
+ 	private function readBinData($bin, $length) {
+ 		$data = substr($bin, $this->readBinDataOffset, $length);
+ 		$this->readBinDataOffset += $length;
+ 
+ 		return bindec($data);
+ 	}
+ 
+ 	public static function bitrateLookup($index) {
+ 		static $lookup = array(
+ 			0  => 32000,
+ 			1  => 56000,
+ 			2  => 64000,
+ 			3  => 96000,
+ 			4  => 112000,
+ 			5  => 128000,
+ 			6  => 192000,
+ 			7  => 224000,
+ 			8  => 256000,
+ 			9  => 320000,
+ 			10 => 384000,
+ 			11 => 448000,
+ 			12 => 512000,
+ 			13 => 576000,
+ 			14 => 640000,
+ 			15 => 768000,
+ 			16 => 960000,
+ 			17 => 1024000,
+ 			18 => 1152000,
+ 			19 => 1280000,
+ 			20 => 1344000,
+ 			21 => 1408000,
+ 			22 => 1411200,
+ 			23 => 1472000,
+ 			24 => 1536000,
+ 			25 => 1920000,
+ 			26 => 2048000,
+ 			27 => 3072000,
+ 			28 => 3840000,
+ 			29 => 'open',
+ 			30 => 'variable',
+ 			31 => 'lossless',
+ 		);
+ 		return (isset($lookup[$index]) ? $lookup[$index] : false);
+ 	}
+ 
+ 	public static function sampleRateLookup($index) {
+ 		static $lookup = array(
+ 			0  => 'invalid',
+ 			1  => 8000,
+ 			2  => 16000,
+ 			3  => 32000,
+ 			4  => 'invalid',
+ 			5  => 'invalid',
+ 			6  => 11025,
+ 			7  => 22050,
+ 			8  => 44100,
+ 			9  => 'invalid',
+ 			10 => 'invalid',
+ 			11 => 12000,
+ 			12 => 24000,
+ 			13 => 48000,
+ 			14 => 'invalid',
+ 			15 => 'invalid',
+ 		);
+ 		return (isset($lookup[$index]) ? $lookup[$index] : false);
+ 	}
+ 
+ 	public static function bitPerSampleLookup($index) {
+ 		static $lookup = array(
+ 			0  => 16,
+ 			1  => 20,
+ 			2  => 24,
+ 			3  => 24,
+ 		);
+ 		return (isset($lookup[$index]) ? $lookup[$index] : false);
+ 	}
+ 
+ 	public static function numChannelsLookup($index) {
+ 		switch ($index) {
+ 			case 0:
+ 				return 1;
+ 				break;
+ 			case 1:
+ 			case 2:
+ 			case 3:
+ 			case 4:
+ 				return 2;
+ 				break;
+ 			case 5:
+ 			case 6:
+ 				return 3;
+ 				break;
+ 			case 7:
+ 			case 8:
+ 				return 4;
+ 				break;
+ 			case 9:
+ 				return 5;
+ 				break;
+ 			case 10:
+ 			case 11:
+ 			case 12:
+ 				return 6;
+ 				break;
+ 			case 13:
+ 				return 7;
+ 				break;
+ 			case 14:
+ 			case 15:
+ 				return 8;
+ 				break;
+ 		}
+ 		return false;
+ 	}
+ 
+ 	public static function channelArrangementLookup($index) {
+ 		static $lookup = array(
+ 			0  => 'A',
+ 			1  => 'A + B (dual mono)',
+ 			2  => 'L + R (stereo)',
+ 			3  => '(L+R) + (L-R) (sum-difference)',
+ 			4  => 'LT + RT (left and right total)',
+ 			5  => 'C + L + R',
+ 			6  => 'L + R + S',
+ 			7  => 'C + L + R + S',
+ 			8  => 'L + R + SL + SR',
+ 			9  => 'C + L + R + SL + SR',
+ 			10 => 'CL + CR + L + R + SL + SR',
+ 			11 => 'C + L + R+ LR + RR + OV',
+ 			12 => 'CF + CR + LF + RF + LR + RR',
+ 			13 => 'CL + C + CR + L + R + SL + SR',
+ 			14 => 'CL + CR + L + R + SL1 + SL2 + SR1 + SR2',
+ 			15 => 'CL + C+ CR + L + R + SL + S + SR',
+ 		);
+ 		return (isset($lookup[$index]) ? $lookup[$index] : 'user-defined');
+ 	}
+ 
+ 	public static function dialogNormalization($index, $version) {
+ 		switch ($version) {
+ 			case 7:
+ 				return 0 - $index;
+ 				break;
+ 			case 6:
+ 				return 0 - 16 - $index;
+ 				break;
+ 		}
+ 		return false;
+ 	}
+ 
+ }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ID3/module.audio.flac.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ID3/module.audio.flac.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ID3/module.audio.flac.php	1969-12-31 18:00:00.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ID3/module.audio.flac.php	2013-03-20 23:55:42.000000000 -0500
***************
*** 0 ****
--- 1,442 ----
+ <?php
+ /////////////////////////////////////////////////////////////////
+ /// getID3() by James Heinrich <info@getid3.org>               //
+ //  available at http://getid3.sourceforge.net                 //
+ //            or http://www.getid3.org                         //
+ /////////////////////////////////////////////////////////////////
+ // See readme.txt for more details                             //
+ /////////////////////////////////////////////////////////////////
+ //                                                             //
+ // module.audio.flac.php                                       //
+ // module for analyzing FLAC and OggFLAC audio files           //
+ // dependencies: module.audio.ogg.php                          //
+ //                                                            ///
+ /////////////////////////////////////////////////////////////////
+ 
+ 
+ getid3_lib::IncludeDependency(GETID3_INCLUDEPATH.'module.audio.ogg.php', __FILE__, true);
+ 
+ /**
+ * @tutorial http://flac.sourceforge.net/format.html
+ */
+ class getid3_flac extends getid3_handler
+ {
+ 	const syncword = 'fLaC';
+ 
+ 	public function Analyze() {
+ 		$info = &$this->getid3->info;
+ 
+ 		$this->fseek($info['avdataoffset']);
+ 		$StreamMarker = $this->fread(4);
+ 		if ($StreamMarker != self::syncword) {
+ 			return $this->error('Expecting "'.getid3_lib::PrintHexBytes(self::syncword).'" at offset '.$info['avdataoffset'].', found "'.getid3_lib::PrintHexBytes($StreamMarker).'"');
+ 		}
+ 		$info['fileformat']            = 'flac';
+ 		$info['audio']['dataformat']   = 'flac';
+ 		$info['audio']['bitrate_mode'] = 'vbr';
+ 		$info['audio']['lossless']     = true;
+ 
+ 		// parse flac container
+ 		return $this->parseMETAdata();
+ 	}
+ 
+ 	public function parseMETAdata() {
+ 		$info = &$this->getid3->info;
+ 		do {
+ 			$BlockOffset   = $this->ftell();
+ 			$BlockHeader   = $this->fread(4);
+ 			$LBFBT         = getid3_lib::BigEndian2Int(substr($BlockHeader, 0, 1));
+ 			$LastBlockFlag = (bool) ($LBFBT & 0x80);
+ 			$BlockType     =        ($LBFBT & 0x7F);
+ 			$BlockLength   = getid3_lib::BigEndian2Int(substr($BlockHeader, 1, 3));
+ 			$BlockTypeText = self::metaBlockTypeLookup($BlockType);
+ 
+ 			if (($BlockOffset + 4 + $BlockLength) > $info['avdataend']) {
+ 				$this->error('METADATA_BLOCK_HEADER.BLOCK_TYPE ('.$BlockTypeText.') at offset '.$BlockOffset.' extends beyond end of file');
+ 				break;
+ 			}
+ 			if ($BlockLength < 1) {
+ 				$this->error('METADATA_BLOCK_HEADER.BLOCK_LENGTH ('.$BlockLength.') at offset '.$BlockOffset.' is invalid');
+ 				break;
+ 			}
+ 
+ 			$info['flac'][$BlockTypeText]['raw'] = array();
+ 			$BlockTypeText_raw = &$info['flac'][$BlockTypeText]['raw'];
+ 
+ 			$BlockTypeText_raw['offset']          = $BlockOffset;
+ 			$BlockTypeText_raw['last_meta_block'] = $LastBlockFlag;
+ 			$BlockTypeText_raw['block_type']      = $BlockType;
+ 			$BlockTypeText_raw['block_type_text'] = $BlockTypeText;
+ 			$BlockTypeText_raw['block_length']    = $BlockLength;
+ 			if ($BlockTypeText_raw['block_type'] != 0x06) { // do not read attachment data automatically
+ 				$BlockTypeText_raw['block_data']  = $this->fread($BlockLength);
+ 			}
+ 
+ 			switch ($BlockTypeText) {
+ 				case 'STREAMINFO':     // 0x00
+ 					if (!$this->parseSTREAMINFO($BlockTypeText_raw['block_data'])) {
+ 						return false;
+ 					}
+ 					break;
+ 
+ 				case 'PADDING':        // 0x01
+ 					unset($info['flac']['PADDING']); // ignore
+ 					break;
+ 
+ 				case 'APPLICATION':    // 0x02
+ 					if (!$this->parseAPPLICATION($BlockTypeText_raw['block_data'])) {
+ 						return false;
+ 					}
+ 					break;
+ 
+ 				case 'SEEKTABLE':      // 0x03
+ 					if (!$this->parseSEEKTABLE($BlockTypeText_raw['block_data'])) {
+ 						return false;
+ 					}
+ 					break;
+ 
+ 				case 'VORBIS_COMMENT': // 0x04
+ 					if (!$this->parseVORBIS_COMMENT($BlockTypeText_raw['block_data'])) {
+ 						return false;
+ 					}
+ 					break;
+ 
+ 				case 'CUESHEET':       // 0x05
+ 					if (!$this->parseCUESHEET($BlockTypeText_raw['block_data'])) {
+ 						return false;
+ 					}
+ 					break;
+ 
+ 				case 'PICTURE':        // 0x06
+ 					if (!$this->parsePICTURE()) {
+ 						return false;
+ 					}
+ 					break;
+ 
+ 				default:
+ 					$this->warning('Unhandled METADATA_BLOCK_HEADER.BLOCK_TYPE ('.$BlockType.') at offset '.$BlockOffset);
+ 			}
+ 
+ 			unset($info['flac'][$BlockTypeText]['raw']);
+ 			$info['avdataoffset'] = $this->ftell();
+ 		}
+ 		while ($LastBlockFlag === false);
+ 
+ 		// handle tags
+ 		if (!empty($info['flac']['VORBIS_COMMENT']['comments'])) {
+ 			$info['flac']['comments'] = $info['flac']['VORBIS_COMMENT']['comments'];
+ 		}
+ 		if (!empty($info['flac']['VORBIS_COMMENT']['vendor'])) {
+ 			$info['audio']['encoder'] = str_replace('reference ', '', $info['flac']['VORBIS_COMMENT']['vendor']);
+ 		}
+ 
+ 		// copy attachments to 'comments' array if nesesary
+ 		if (isset($info['flac']['PICTURE']) && ($this->getid3->option_save_attachments !== getID3::ATTACHMENTS_NONE)) {
+ 			foreach ($info['flac']['PICTURE'] as $entry) {
+ 				if (!empty($entry['data'])) {
+ 					$info['flac']['comments']['picture'][] = array('image_mime'=>$entry['image_mime'], 'data'=>$entry['data']);
+ 				}
+ 			}
+ 		}
+ 
+ 		if (isset($info['flac']['STREAMINFO'])) {
+ 			if (!$this->isDependencyFor('matroska')) {
+ 				$info['flac']['compressed_audio_bytes'] = $info['avdataend'] - $info['avdataoffset'];
+ 			}
+ 			$info['flac']['uncompressed_audio_bytes'] = $info['flac']['STREAMINFO']['samples_stream'] * $info['flac']['STREAMINFO']['channels'] * ($info['flac']['STREAMINFO']['bits_per_sample'] / 8);
+ 			if ($info['flac']['uncompressed_audio_bytes'] == 0) {
+ 				return $this->error('Corrupt FLAC file: uncompressed_audio_bytes == zero');
+ 			}
+ 			if (!empty($info['flac']['compressed_audio_bytes'])) {
+ 				$info['flac']['compression_ratio'] = $info['flac']['compressed_audio_bytes'] / $info['flac']['uncompressed_audio_bytes'];
+ 			}
+ 		}
+ 
+ 		// set md5_data_source - built into flac 0.5+
+ 		if (isset($info['flac']['STREAMINFO']['audio_signature'])) {
+ 
+ 			if ($info['flac']['STREAMINFO']['audio_signature'] === str_repeat("\x00", 16)) {
+                 $this->warning('FLAC STREAMINFO.audio_signature is null (known issue with libOggFLAC)');
+ 			}
+ 			else {
+ 				$info['md5_data_source'] = '';
+ 				$md5 = $info['flac']['STREAMINFO']['audio_signature'];
+ 				for ($i = 0; $i < strlen($md5); $i++) {
+ 					$info['md5_data_source'] .= str_pad(dechex(ord($md5[$i])), 2, '00', STR_PAD_LEFT);
+ 				}
+ 				if (!preg_match('/^[0-9a-f]{32}$/', $info['md5_data_source'])) {
+ 					unset($info['md5_data_source']);
+ 				}
+ 			}
+ 		}
+ 
+ 		if (isset($info['flac']['STREAMINFO']['bits_per_sample'])) {
+ 			$info['audio']['bits_per_sample'] = $info['flac']['STREAMINFO']['bits_per_sample'];
+ 			if ($info['audio']['bits_per_sample'] == 8) {
+ 				// special case
+ 				// must invert sign bit on all data bytes before MD5'ing to match FLAC's calculated value
+ 				// MD5sum calculates on unsigned bytes, but FLAC calculated MD5 on 8-bit audio data as signed
+ 				$this->warning('FLAC calculates MD5 data strangely on 8-bit audio, so the stored md5_data_source value will not match the decoded WAV file');
+ 			}
+ 		}
+ 
+ 		return true;
+ 	}
+ 
+ 	private function parseSTREAMINFO($BlockData) {
+ 		$info = &$this->getid3->info;
+ 
+ 		$info['flac']['STREAMINFO'] = array();
+ 		$streaminfo = &$info['flac']['STREAMINFO'];
+ 
+ 		$streaminfo['min_block_size']  = getid3_lib::BigEndian2Int(substr($BlockData, 0, 2));
+ 		$streaminfo['max_block_size']  = getid3_lib::BigEndian2Int(substr($BlockData, 2, 2));
+ 		$streaminfo['min_frame_size']  = getid3_lib::BigEndian2Int(substr($BlockData, 4, 3));
+ 		$streaminfo['max_frame_size']  = getid3_lib::BigEndian2Int(substr($BlockData, 7, 3));
+ 
+ 		$SRCSBSS                       = getid3_lib::BigEndian2Bin(substr($BlockData, 10, 8));
+ 		$streaminfo['sample_rate']     = getid3_lib::Bin2Dec(substr($SRCSBSS,  0, 20));
+ 		$streaminfo['channels']        = getid3_lib::Bin2Dec(substr($SRCSBSS, 20,  3)) + 1;
+ 		$streaminfo['bits_per_sample'] = getid3_lib::Bin2Dec(substr($SRCSBSS, 23,  5)) + 1;
+ 		$streaminfo['samples_stream']  = getid3_lib::Bin2Dec(substr($SRCSBSS, 28, 36));
+ 
+ 		$streaminfo['audio_signature'] = substr($BlockData, 18, 16);
+ 
+ 		if (!empty($streaminfo['sample_rate'])) {
+ 
+ 			$info['audio']['bitrate_mode']    = 'vbr';
+ 			$info['audio']['sample_rate']     = $streaminfo['sample_rate'];
+ 			$info['audio']['channels']        = $streaminfo['channels'];
+ 			$info['audio']['bits_per_sample'] = $streaminfo['bits_per_sample'];
+ 			$info['playtime_seconds']         = $streaminfo['samples_stream'] / $streaminfo['sample_rate'];
+ 			if ($info['playtime_seconds'] > 0) {
+ 				if (!$this->isDependencyFor('matroska')) {
+ 					$info['audio']['bitrate'] = (($info['avdataend'] - $info['avdataoffset']) * 8) / $info['playtime_seconds'];
+ 				}
+ 				else {
+ 					$this->warning('Cannot determine audio bitrate because total stream size is unknown');
+ 				}
+ 			}
+ 
+ 		} else {
+ 			return $this->error('Corrupt METAdata block: STREAMINFO');
+ 		}
+ 
+ 		return true;
+ 	}
+ 
+ 	private function parseAPPLICATION($BlockData) {
+ 		$info = &$this->getid3->info;
+ 
+ 		$ApplicationID = getid3_lib::BigEndian2Int(substr($BlockData, 0, 4));
+ 		$info['flac']['APPLICATION'][$ApplicationID]['name'] = self::applicationIDLookup($ApplicationID);
+ 		$info['flac']['APPLICATION'][$ApplicationID]['data'] = substr($BlockData, 4);
+ 
+ 		return true;
+ 	}
+ 
+ 	private function parseSEEKTABLE($BlockData) {
+ 		$info = &$this->getid3->info;
+ 
+ 		$offset = 0;
+ 		$BlockLength = strlen($BlockData);
+ 		$placeholderpattern = str_repeat("\xFF", 8);
+ 		while ($offset < $BlockLength) {
+ 			$SampleNumberString = substr($BlockData, $offset, 8);
+ 			$offset += 8;
+ 			if ($SampleNumberString == $placeholderpattern) {
+ 
+ 				// placeholder point
+ 				getid3_lib::safe_inc($info['flac']['SEEKTABLE']['placeholders'], 1);
+ 				$offset += 10;
+ 
+ 			} else {
+ 
+ 				$SampleNumber                                        = getid3_lib::BigEndian2Int($SampleNumberString);
+ 				$info['flac']['SEEKTABLE'][$SampleNumber]['offset']  = getid3_lib::BigEndian2Int(substr($BlockData, $offset, 8));
+ 				$offset += 8;
+ 				$info['flac']['SEEKTABLE'][$SampleNumber]['samples'] = getid3_lib::BigEndian2Int(substr($BlockData, $offset, 2));
+ 				$offset += 2;
+ 
+ 			}
+ 		}
+ 
+ 		return true;
+ 	}
+ 
+ 	private function parseVORBIS_COMMENT($BlockData) {
+ 		$info = &$this->getid3->info;
+ 
+ 		$getid3_ogg = new getid3_ogg($this->getid3);
+ 		if ($this->isDependencyFor('matroska')) {
+ 			$getid3_ogg->setStringMode($this->data_string);
+ 		}
+ 		$getid3_ogg->ParseVorbisComments();
+ 		if (isset($info['ogg'])) {
+ 			unset($info['ogg']['comments_raw']);
+ 			$info['flac']['VORBIS_COMMENT'] = $info['ogg'];
+ 			unset($info['ogg']);
+ 		}
+ 
+ 		unset($getid3_ogg);
+ 
+ 		return true;
+ 	}
+ 
+ 	private function parseCUESHEET($BlockData) {
+ 		$info = &$this->getid3->info;
+ 		$offset = 0;
+ 		$info['flac']['CUESHEET']['media_catalog_number'] =                              trim(substr($BlockData, $offset, 128), "\0");
+ 		$offset += 128;
+ 		$info['flac']['CUESHEET']['lead_in_samples']      =         getid3_lib::BigEndian2Int(substr($BlockData, $offset, 8));
+ 		$offset += 8;
+ 		$info['flac']['CUESHEET']['flags']['is_cd']       = (bool) (getid3_lib::BigEndian2Int(substr($BlockData, $offset, 1)) & 0x80);
+ 		$offset += 1;
+ 
+ 		$offset += 258; // reserved
+ 
+ 		$info['flac']['CUESHEET']['number_tracks']        =         getid3_lib::BigEndian2Int(substr($BlockData, $offset, 1));
+ 		$offset += 1;
+ 
+ 		for ($track = 0; $track < $info['flac']['CUESHEET']['number_tracks']; $track++) {
+ 			$TrackSampleOffset = getid3_lib::BigEndian2Int(substr($BlockData, $offset, 8));
+ 			$offset += 8;
+ 			$TrackNumber       = getid3_lib::BigEndian2Int(substr($BlockData, $offset, 1));
+ 			$offset += 1;
+ 
+ 			$info['flac']['CUESHEET']['tracks'][$TrackNumber]['sample_offset']         = $TrackSampleOffset;
+ 
+ 			$info['flac']['CUESHEET']['tracks'][$TrackNumber]['isrc']                  =                           substr($BlockData, $offset, 12);
+ 			$offset += 12;
+ 
+ 			$TrackFlagsRaw                                                             = getid3_lib::BigEndian2Int(substr($BlockData, $offset, 1));
+ 			$offset += 1;
+ 			$info['flac']['CUESHEET']['tracks'][$TrackNumber]['flags']['is_audio']     = (bool) ($TrackFlagsRaw & 0x80);
+ 			$info['flac']['CUESHEET']['tracks'][$TrackNumber]['flags']['pre_emphasis'] = (bool) ($TrackFlagsRaw & 0x40);
+ 
+ 			$offset += 13; // reserved
+ 
+ 			$info['flac']['CUESHEET']['tracks'][$TrackNumber]['index_points']          = getid3_lib::BigEndian2Int(substr($BlockData, $offset, 1));
+ 			$offset += 1;
+ 
+ 			for ($index = 0; $index < $info['flac']['CUESHEET']['tracks'][$TrackNumber]['index_points']; $index++) {
+ 				$IndexSampleOffset = getid3_lib::BigEndian2Int(substr($BlockData, $offset, 8));
+ 				$offset += 8;
+ 				$IndexNumber       = getid3_lib::BigEndian2Int(substr($BlockData, $offset, 1));
+ 				$offset += 1;
+ 
+ 				$offset += 3; // reserved
+ 
+ 				$info['flac']['CUESHEET']['tracks'][$TrackNumber]['indexes'][$IndexNumber] = $IndexSampleOffset;
+ 			}
+ 		}
+ 
+ 		return true;
+ 	}
+ 
+ 	/**
+ 	* Parse METADATA_BLOCK_PICTURE flac structure and extract attachment
+ 	* External usage: audio.ogg
+ 	*/
+ 	public function parsePICTURE() {
+ 		$info = &$this->getid3->info;
+ 
+ 		$picture['typeid']         = getid3_lib::BigEndian2Int($this->fread(4));
+ 		$picture['type']           = self::pictureTypeLookup($picture['typeid']);
+ 		$picture['image_mime']     = $this->fread(getid3_lib::BigEndian2Int($this->fread(4)));
+ 		$descr_length              = getid3_lib::BigEndian2Int($this->fread(4));
+ 		if ($descr_length) {
+ 			$picture['description'] = $this->fread($descr_length);
+ 		}
+ 		$picture['width']          = getid3_lib::BigEndian2Int($this->fread(4));
+ 		$picture['height']         = getid3_lib::BigEndian2Int($this->fread(4));
+ 		$picture['color_depth']    = getid3_lib::BigEndian2Int($this->fread(4));
+ 		$picture['colors_indexed'] = getid3_lib::BigEndian2Int($this->fread(4));
+ 		$data_length               = getid3_lib::BigEndian2Int($this->fread(4));
+ 
+ 		if ($picture['image_mime'] == '-->') {
+ 			$picture['data'] = $this->fread($data_length);
+ 		} else {
+ 			$picture['data'] = $this->saveAttachment(
+ 				str_replace('/', '_', $picture['type']).'_'.$this->ftell(),
+ 				$this->ftell(),
+ 				$data_length,
+ 				$picture['image_mime']);
+ 		}
+ 
+ 		$info['flac']['PICTURE'][] = $picture;
+ 
+ 		return true;
+ 	}
+ 
+ 	public static function metaBlockTypeLookup($blocktype) {
+ 		static $lookup = array(
+ 			0 => 'STREAMINFO',
+ 			1 => 'PADDING',
+ 			2 => 'APPLICATION',
+ 			3 => 'SEEKTABLE',
+ 			4 => 'VORBIS_COMMENT',
+ 			5 => 'CUESHEET',
+ 			6 => 'PICTURE',
+ 		);
+ 		return (isset($lookup[$blocktype]) ? $lookup[$blocktype] : 'reserved');
+ 	}
+ 
+ 	public static function applicationIDLookup($applicationid) {
+ 		// http://flac.sourceforge.net/id.html
+ 		static $lookup = array(
+ 			0x41544348 => 'FlacFile',                                                                           // "ATCH"
+ 			0x42534F4C => 'beSolo',                                                                             // "BSOL"
+ 			0x42554753 => 'Bugs Player',                                                                        // "BUGS"
+ 			0x43756573 => 'GoldWave cue points (specification)',                                                // "Cues"
+ 			0x46696361 => 'CUE Splitter',                                                                       // "Fica"
+ 			0x46746F6C => 'flac-tools',                                                                         // "Ftol"
+ 			0x4D4F5442 => 'MOTB MetaCzar',                                                                      // "MOTB"
+ 			0x4D505345 => 'MP3 Stream Editor',                                                                  // "MPSE"
+ 			0x4D754D4C => 'MusicML: Music Metadata Language',                                                   // "MuML"
+ 			0x52494646 => 'Sound Devices RIFF chunk storage',                                                   // "RIFF"
+ 			0x5346464C => 'Sound Font FLAC',                                                                    // "SFFL"
+ 			0x534F4E59 => 'Sony Creative Software',                                                             // "SONY"
+ 			0x5351455A => 'flacsqueeze',                                                                        // "SQEZ"
+ 			0x54745776 => 'TwistedWave',                                                                        // "TtWv"
+ 			0x55495453 => 'UITS Embedding tools',                                                               // "UITS"
+ 			0x61696666 => 'FLAC AIFF chunk storage',                                                            // "aiff"
+ 			0x696D6167 => 'flac-image application for storing arbitrary files in APPLICATION metadata blocks',  // "imag"
+ 			0x7065656D => 'Parseable Embedded Extensible Metadata (specification)',                             // "peem"
+ 			0x71667374 => 'QFLAC Studio',                                                                       // "qfst"
+ 			0x72696666 => 'FLAC RIFF chunk storage',                                                            // "riff"
+ 			0x74756E65 => 'TagTuner',                                                                           // "tune"
+ 			0x78626174 => 'XBAT',                                                                               // "xbat"
+ 			0x786D6364 => 'xmcd',                                                                               // "xmcd"
+ 		);
+ 		return (isset($lookup[$applicationid]) ? $lookup[$applicationid] : 'reserved');
+ 	}
+ 
+ 	public static function pictureTypeLookup($type_id) {
+ 		static $lookup = array (
+ 			 0 => 'Other',
+ 			 1 => '32x32 pixels \'file icon\' (PNG only)',
+ 			 2 => 'Other file icon',
+ 			 3 => 'Cover (front)',
+ 			 4 => 'Cover (back)',
+ 			 5 => 'Leaflet page',
+ 			 6 => 'Media (e.g. label side of CD)',
+ 			 7 => 'Lead artist/lead performer/soloist',
+ 			 8 => 'Artist/performer',
+ 			 9 => 'Conductor',
+ 			10 => 'Band/Orchestra',
+ 			11 => 'Composer',
+ 			12 => 'Lyricist/text writer',
+ 			13 => 'Recording Location',
+ 			14 => 'During recording',
+ 			15 => 'During performance',
+ 			16 => 'Movie/video screen capture',
+ 			17 => 'A bright coloured fish',
+ 			18 => 'Illustration',
+ 			19 => 'Band/artist logotype',
+ 			20 => 'Publisher/Studio logotype',
+ 		);
+ 		return (isset($lookup[$type_id]) ? $lookup[$type_id] : 'reserved');
+ 	}
+ 
+ }
